cd /opt/SWE-bench
cp /opt/auto-code-rover/conf/swe_lite_tasks.txt tasks.txt


# Set up the conda environment
source /root/miniconda3/etc/profile.d/conda.sh
conda init
conda activate swe-bench

python harness/run_setup.py --log_dir logs --testbed testbed --result_dir setup_result --subset_file tasks.txt --num_processes 5

cd /opt/auto-code-rover
source secret.sh
conda activate auto-code-rover

PYTHONPATH=. python app/main.py swe-bench --model claude-3-haiku-20240307 --setup-map ../SWE-bench/setup_result/setup_map.json --tasks-map ../SWE-bench/setup_result/tasks_map.json --output-dir output_haiku --task-list-file /opt/SWE-bench/tasks.txt --num-processes 20 --model-temperature 0 --conv-round-limit 10

PYTHONPATH=. python app/main.py swe-bench --model "mistralai/Mixtral-8x7B-Instruct-v0.1" --setup-map ../SWE-bench/setup_result/setup_map.json --tasks-map ../SWE-bench/setup_result/tasks_map.json --output-dir output_mixtral --task-list-file /opt/SWE-bench/tasks.txt --num-processes 20 --model-temperature 0 --conv-round-limit 10
